require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/profil_authorizes', type: :request do
  # ProfilAuthorize. As you add validations to ProfilAuthorize, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {profil_id: profil.id, meth_step_role_id: step_role.id} }
  let(:invalid_attributes) { {profil_id: profil.id, meth_step_role_id: nil} }

  let(:profil) { FactoryBot.create(:profil) }
  let(:step_role) { FactoryBot.create(:meth_step_role) }
  let(:user) { FactoryBot.create(:user) }

  before :each do
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      ProfilAuthorize.create! valid_attributes
      # binding.pry
      get profil_authorizes_url
      expect(response).to be_successful
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {profil_id: profil2.id} }
      let(:profil2) { FactoryBot.create(:profil) }

      it 'updates the requested profil_authorize' do
        profil_authorize = ProfilAuthorize.create! valid_attributes
        patch profil_authorize_url(profil_authorize), params: { profil_authorize: new_attributes }
        profil_authorize.reload

        expect(profil_authorize.profil_id).to eq profil2.id
      end

      it 'redirects to the profil_authorize' do
        profil_authorize = ProfilAuthorize.create! valid_attributes
        patch profil_authorize_url(profil_authorize), params: { profil_authorize: new_attributes }
        profil_authorize.reload
        expect(response).to redirect_to(profil_authorize_url(profil_authorize))
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        profil_authorize = ProfilAuthorize.create! valid_attributes
        patch profil_authorize_url(profil_authorize), params: { profil_authorize: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end
end
